# Appends the content of a source collection of shapefiles into a
# destination collection of shapefiles. Each collection directory
# should already contain a file "ishape_last.txt". Assuming the first
# date of the source collection is one more day than the last date of
# the destination collection.

if (($# != 2))
then
    echo "Usage: shp_coll_append.sh from_coll to_coll"
    exit 1
fi

set -e
##set -x

for my_base in extremum outermost_contour max_speed_contour centroid
do
    if [[ -f $1/$my_base.shp ]]
    then
	shpcat $1/$my_base $2/$my_base
	dbfcat $1/$my_base $2/$my_base
    fi
done

i2=`tail -1 $2/ishape_last.txt`

while read i1
do
    echo $((i2 + 1 + i1)) >>$2/ishape_last.txt
done <$1/ishape_last.txt
